// ---------------------------------------------------*- C++ -*--------------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilocollectionoperatorH
#define __CONCERT_ilocollectionoperatorH

#if !defined(__CONCERT_ilotuplecollectionH)
# include <ilconcert/ilotuplecollection.h>
#endif
#if !defined(__CONCERT_ilosymbolH)
# include <ilconcert/ilosymbol.h>
#endif
#if !defined(__CONCERT_iloanyexpriH)
# include <ilconcert/iloanyexpri.h>
#endif

class IloIntExprArg;
class IloNumExprArg;
class IloTupleExprArg;

IloIntSet IloUnion(IloIntSet set1, IloIntSet set2);
IloNumSet IloUnion(IloNumSet set1, IloNumSet set2);
IloAnySet IloUnion(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloUnion(IloSymbolSet set1, IloSymbolSet set2);


IloTupleSet IloUnion(IloTupleSet set1, IloTupleSet set2);

IloInt IloFirst(IloIntSet set);
IloNum IloFirst(IloNumSet set);
IloAny IloFirst(IloAnySet set);
IloSymbol IloFirst(IloSymbolSet set);

IloTuple IloFirst(IloTupleSet set);

IloInt IloLast(IloIntSet set);
IloNum IloLast(IloNumSet set);
IloAny IloLast(IloAnySet set);
IloSymbol IloLast(IloSymbolSet set);


IloTuple IloLast(IloTupleSet set);


IloIntSet IloExclude(IloIntSet set1, IloIntSet set2);
IloNumSet IloExclude(IloNumSet set1, IloNumSet set2);
IloAnySet IloExclude(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloExclude(IloSymbolSet set1, IloSymbolSet set2);

IloTupleSet IloExclude(IloTupleSet set1, IloTupleSet set2);


IloIntSet IloSymExclude(IloIntSet set1, IloIntSet set2);
IloNumSet IloSymExclude(IloNumSet set1, IloNumSet set2);
IloAnySet IloSymExclude(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloSymExclude(IloSymbolSet set1, IloSymbolSet set2);

IloTupleSet IloSymExclude(IloTupleSet set1, IloTupleSet set2);






IloIntSet IloInter(IloIntSet set1, IloIntSet set2);
IloNumSet IloInter(IloNumSet set1, IloNumSet set2);
IloAnySet IloInter(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloInter(IloSymbolSet set1, IloSymbolSet set2);

IloTupleSet IloInter(IloTupleSet set1, IloTupleSet set2);

IloTupleSet IloInter(IloTupleSet set1, IloTupleSet set2, IloIntArray idx, IloArray<IloDiscreteDataCollectionI*> references);
IloTupleSet IloUnion(IloTupleSet set1, IloTupleSet set2, IloIntArray idx, IloArray<IloDiscreteDataCollectionI*> references);
IloTupleSet IloExclude(IloTupleSet set1, IloTupleSet set2, IloIntArray idx, IloArray<IloDiscreteDataCollectionI*> references);
IloTupleSet IloSymExclude(IloTupleSet set1, IloTupleSet set2, IloIntArray idx, IloArray<IloDiscreteDataCollectionI*> references);


IloInt IloNext(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloNext(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloNext(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloNext(IloTupleSet set, IloTuple value, IloInt n=1);

IloSymbol IloNext(IloSymbolSet set, IloSymbol value, IloInt n=1);



//=================================================

IloInt IloPrevious(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloPrevious(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloPrevious(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloPrevious(IloTupleSet set, IloTuple value, IloInt n=1);
IloSymbol IloPrevious(IloSymbolSet set, IloSymbol value, IloInt n=1);

IloInt IloNextC(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloNextC(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloNextC(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloNextC(IloTupleSet set, IloTuple value, IloInt n=1);

IloSymbol IloNextC(IloSymbolSet set, IloSymbol value, IloInt n=1);

IloInt IloPreviousC(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloPreviousC(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloPreviousC(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloPreviousC(IloTupleSet set, IloTuple value, IloInt n=1);

IloSymbol IloPreviousC(IloSymbolSet set, IloSymbol value, IloInt n=1);


//====================================================


class IloIntCollectionExprArg;
class IloNumCollectionExprArg;
class IloSymbolCollectionExprArg;

IloIntExprArg IloNext(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloNext(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);
IloIntExprArg IloPrevious(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloPrevious(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);
IloIntExprArg IloNextC(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloNextC(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);
IloIntExprArg IloPreviousC(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloPreviousC(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);


IloNumExprArg IloNext(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloNext(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);
IloNumExprArg IloPrevious(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloPrevious(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);
IloNumExprArg IloNextC(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloNextC(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);
IloNumExprArg IloPreviousC(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloPreviousC(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);

IloSymbolExprArg IloNext(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloNext(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);
IloSymbolExprArg IloPrevious(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloPrevious(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);
IloSymbolExprArg IloNextC(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloNextC(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);
IloSymbolExprArg IloPreviousC(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloPreviousC(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);


class IloNumCollectionExprOperatorI : public IloNumExprI {
	ILOEXTRDECL
private:
	IloNumCollectionExprI* _coll;
	IloNumExprI* _expr;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloNumCollectionExprI* getNumCollectionExpr() const { return _coll; }
	IloNumExprI* getNumExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloNumCollectionExprOperatorI(IloEnvI* env,
		IloNumCollectionExprI* coll,
		IloNumExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue);
	virtual ~IloNumCollectionExprOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	virtual IloBool isInteger() const;
};


class IloIntCollectionExprOperatorI : public IloIntExprI {
	ILOEXTRDECL
private:
	IloIntCollectionExprI* _coll;
	IloIntExprI* _expr;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloIntCollectionExprI* getIntCollectionExpr() const { return _coll; }
	IloIntExprI* getIntExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloIntCollectionExprOperatorI(IloEnvI* env,
		IloIntCollectionExprI* coll,
		IloIntExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue);
	virtual ~IloIntCollectionExprOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
};


class IloSymbolCollectionExprOperatorI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _coll;
	IloAnyExprI* _expr;
	IloIntExprArgI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloAnyCollectionExprI* getAnyCollectionExpr() const { return _coll; }
	IloAnyExprI* getAnyExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloSymbolCollectionExprOperatorI(IloEnvI* env,
		IloAnyCollectionExprI* coll,
		IloAnyExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue);
	virtual ~IloSymbolCollectionExprOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};

//============================

class IloNumCollectionExprItemI : public IloNumExprI {
	ILOEXTRDECL
private:
	IloNumCollectionExprI* _coll;
	IloIntExprI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloNumCollectionExprI* getNumCollectionExpr() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloNumCollectionExprItemI(IloEnvI* env,
		IloNumCollectionExprI* coll,
		IloIntExprI* offset = 0);
	virtual ~IloNumCollectionExprItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	virtual IloBool isInteger() const;
};


class IloIntCollectionExprItemI : public IloIntExprI {
	ILOEXTRDECL
private:
	IloIntCollectionExprI* _coll;
	IloIntExprI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloIntCollectionExprI* getIntCollectionExpr() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloIntCollectionExprItemI(IloEnvI* env,
		IloIntCollectionExprI* coll,
		IloIntExprI* offset = 0);
	virtual ~IloIntCollectionExprItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
};


class IloSymbolCollectionExprItemI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _coll;
	IloIntExprArgI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloAnyCollectionExprI* getAnyCollectionExpr() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloSymbolCollectionExprItemI(IloEnvI* env,
		IloAnyCollectionExprI* coll,
		IloIntExprI* offset = 0);
	virtual ~IloSymbolCollectionExprItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};


IloIntExprArg IloItem(IloIntCollectionExprArg set, IloIntExprArg n);
IloNumExprArg IloItem(IloNumCollectionExprArg set, IloIntExprArg n);
IloSymbolExprArg IloItem(IloSymbolCollectionExprArg set, IloIntExprArg n);


class IloOperatorException : public IloException {
	enum Type{
		Undefined,
		Tuple,
		Int,
		Num,
		Extractable,
		Symbol,
		DataCollection
	};
private:
	//IloTupleI* _tuple;
	//IloExtractableI* _extract;
	//IloSymbolI* _symbol;
	//IloDiscreteDataCollectionI *_discreteColl;
	//IloAny _any;
	//IloInt _int;
	//IloNum _num;
	IloTuplePath::IloTupleCell _cell;

	Type _type;

	IloBool _isNext;
	IloBool _isCirc;

public:
	IloOperatorException( IloTupleI* value, IloBool isNext, IloBool isCirc = false );
	IloOperatorException( IloExtractableI* value, IloBool isNext, IloBool isCirc = false );
	IloOperatorException( IloAny value, IloBool isNext, IloBool isCirc = false );
	IloOperatorException( IloInt value, IloBool isNext, IloBool isCirc = false );
	IloOperatorException( IloNum value, IloBool isNext, IloBool isCirc = false );

	virtual ~IloOperatorException();

	const char* getOperatorName() const;
	IloTuple getTuple() const;
	IloInt getInt() const;
	IloNum getNum() const;
	IloSymbol getSymbol() const;
	IloDiscreteDataCollection getDataCollection() const;
	IloExtractable getExtractable() const;

	void printExpr(ILOSTD(ostream)& out) const;

	IloBool isTuple() const { return Tuple == _type; }
	IloBool isInt() const { return Int == _type; }
	IloBool isNum() const { return Num == _type; }
	IloBool isExtractable() const { return Extractable == _type; }
	IloBool isSymbol() const { return Symbol == _type; }
	IloBool isDataCollection() const { return DataCollection == _type; }

	IloBool isNext() const { return _isNext; }
	IloBool isCirc() const { return _isCirc; }
};

class IloCollectionElementNotFoundException : public IloOperatorException {

public:

	IloCollectionElementNotFoundException( IloTupleI* value, IloBool isNext, IloBool isCirc );
	IloCollectionElementNotFoundException( IloExtractableI* value, IloBool isNext, IloBool isCirc );
	IloCollectionElementNotFoundException( IloAny value, IloBool isNext, IloBool isCirc );
	IloCollectionElementNotFoundException( IloInt value, IloBool isNext, IloBool isCirc );
	IloCollectionElementNotFoundException( IloNum value, IloBool isNext, IloBool isCirc );

	virtual ~IloCollectionElementNotFoundException();

	virtual void print(ILOSTD(ostream)& out) const;
	virtual const char* getMessage() const;
};

class IloOperatorNextElementNotFoundException : public IloOperatorException {

public:
	IloOperatorNextElementNotFoundException( IloTupleI* value, IloBool isNext );
	IloOperatorNextElementNotFoundException( IloExtractableI* value, IloBool isNext );
	IloOperatorNextElementNotFoundException( IloAny value, IloBool isNext );
	IloOperatorNextElementNotFoundException( IloInt value, IloBool isNext );
	IloOperatorNextElementNotFoundException( IloNum value, IloBool isNext );
	virtual ~IloOperatorNextElementNotFoundException();

	virtual void print(ILOSTD(ostream)& out) const;
	virtual const char* getMessage() const;
};

#endif
