// -------------------------------------------------------*- C++ -*----------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilocollexpriH
#define __CONCERT_ilocollexpriH

#if !defined(__CONCERT_iloforallbaseH)
# include <ilconcert/iloforallbase.h>
#endif
#if !defined(__CONCERT_ilotupleH)
# include <ilconcert/ilotuple.h>
#endif
#if !defined(__CONCERT_iloforalliH)
# include <ilconcert/iloforalli.h>
#endif
 
#if !defined(__CONCERT_ilointcollexpriH)
# include <ilconcert/ilocollexpr/ilointcollexpri.h>
#endif
#if !defined(__CONCERT_ilonumcollexpriH)
# include <ilconcert/ilocollexpr/ilonumcollexpri.h>
#endif
#if !defined(__CONCERT_iloanycollexpriH)
# include <ilconcert/ilocollexpr/iloanycollexpri.h>
#endif


//--------------------------------------------------------------
/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionCardI </p>
**/
class IloIntCollectionCardI : public IloIntExprI {
	ILOEXTRDECL
		IloIntCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloIntCollectionCardI(IloEnvI* env, IloIntCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionCardI();
	/* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionMinI </p>
**/
class IloIntCollectionMinI : public IloIntExprI {
	ILOEXTRDECL
		IloIntCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloIntCollectionMinI(IloEnvI* env, IloIntCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionMinI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionMaxI </p>
**/
class IloIntCollectionMaxI : public IloIntExprI {
	ILOEXTRDECL
		IloIntCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloIntCollectionMaxI(IloEnvI* env, IloIntCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionMaxI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntExprI* getExpr() const { return _expr; }
};

//-----------------------------------------------------------------------

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionCardI </p>
**/
class IloNumCollectionCardI : public IloIntExprI {
	ILOEXTRDECL
		IloNumCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public: 
	/* <p> . </p> */
	IloNumCollectionCardI(IloEnvI* env, IloNumCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionCardI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionMinI </p>
**/
class IloNumCollectionMinI : public IloNumExprI {
	ILOEXTRDECL
		IloNumCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionMinI(IloEnvI* env, IloNumCollectionExprArgI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionMinI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionMaxI </p>
**/
class IloNumCollectionMaxI : public IloNumExprI {
	ILOEXTRDECL
		IloNumCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionMaxI(IloEnvI* env, IloNumCollectionExprArgI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionMaxI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumExprI* getExpr() const { return _expr; }
};


//------------------------------------------

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionCardI </p>
**/
class IloSymbolCollectionCardI : public IloIntExprI {
	ILOEXTRDECL
		IloSymbolCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloSymbolCollectionCardI(IloEnvI* env, IloSymbolCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloSymbolCollectionCardI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloAnyExprI* getExpr() const { return _expr; }
};



/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionExprMemberI </p>
**/
class IloIntCollectionExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloIntExprI* _exp;
	IloIntCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloIntCollectionExprMemberI(IloEnvI* env, IloIntExprI* exp, IloIntCollectionExprArgI* coll);
	/* <p> . </p> */
	virtual ~IloIntCollectionExprMemberI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloIntExprI* getExpr() const { return _exp; }
	/* <p> . </p> */
	IloIntCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionExprMemberI </p>
**/
class IloNumCollectionExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloNumExprI* _exp;
	IloNumCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloNumCollectionExprMemberI(IloEnvI* env, IloNumExprI* exp, IloNumCollectionExprArgI* coll);
	/* <p> . </p> */
	virtual ~IloNumCollectionExprMemberI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloNumExprI* getExpr() const { return _exp; }
	/* <p> . </p> */
	IloNumCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};


/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloAnyCollectionExprMemberI </p>
**/
class IloAnyCollectionExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloAnyExprI* _exp;
	IloAnyCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloAnyCollectionExprMemberI(IloEnvI* env, IloAnyExprI* exp, IloAnyCollectionExprArgI* coll);
	virtual ~IloAnyCollectionExprMemberI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloAnyExprI* getExpr() const { return _exp; }
	/* <p> . </p> */
	IloAnyCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};


//
/**
 * @group optim.concert.adv
 * @show internal
 * <p> IloIntOrdI </p> **/
class IloIntCollectionOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloIntCollectionExprI* _coll;
  IloIntExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionOrdI(IloEnvI* env, IloIntCollectionExprI* coll, IloIntExprI* expr) : 
    IloIntExprI(env), _coll(coll->intLockExpr()), _expr(expr->intLockExpr()) {}
  virtual ~IloIntCollectionOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloIntCollectionExprI* getCollection() const { return _coll; }
  IloIntExprI* getExpr() const { return _expr; }
};

/**
 * @group optim.concert.adv
 * @show internal
 * <p> IloNumOrdI </p> **/
class IloNumCollectionOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloNumCollectionExprI* _coll;
  IloNumExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionOrdI(IloEnvI* env, IloNumCollectionExprI* coll, IloNumExprI* expr) : 
    IloIntExprI(env), _coll(coll->lockExpr()), _expr(expr->lockExpr()) {}
  virtual ~IloNumCollectionOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloNumCollectionExprI* getCollection() const { return _coll; }
  IloNumExprI* getExpr() const { return _expr; }
};


/**
 * @group optim.concert.adv
 * @show internal
 * <p> IloSymbolOrdI </p> **/
class IloSymbolCollectionOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloAnyCollectionExprI* _coll;
  IloAnyExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloSymbolCollectionOrdI(IloEnvI* env, IloAnyCollectionExprI* coll, IloAnyExprI* expr) : 
    IloIntExprI(env), _coll(coll->lockExpr()), _expr(expr->lockExpr()) {}
  virtual ~IloSymbolCollectionOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloAnyCollectionExprI* getCollection() const { return _coll; }
  IloAnyExprI* getExpr() const { return _expr; }
};




/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionFirstI </p>
**/
class IloIntCollectionFirstI : public IloIntExprI {
	ILOEXTRDECL
	IloIntCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public: 
	/* <p> . </p> */
	IloIntCollectionFirstI(IloEnvI* env, IloIntCollectionExprI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionFirstI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntCollectionExprArgI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionFirstI </p>
**/
class IloNumCollectionFirstI : public IloNumExprI {
	ILOEXTRDECL
	IloNumCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionFirstI(IloEnvI* env, IloNumCollectionExprI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionFirstI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumCollectionExprArgI* getExpr() const { return _expr; }
};





/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionLastI </p>
**/
class IloIntCollectionLastI : public IloIntExprI {
	ILOEXTRDECL
	IloIntCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public: 
	/* <p> . </p> */
	IloIntCollectionLastI(IloEnvI* env, IloIntCollectionExprI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionLastI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntCollectionExprArgI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionLastI </p>
**/
class IloNumCollectionLastI : public IloNumExprI {
	ILOEXTRDECL
	IloNumCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionLastI(IloEnvI* env, IloNumCollectionExprI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionLastI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumCollectionExprArgI* getExpr() const { return _expr; }
};



/**
* @group optim.concert.adv
* @show internal
* <p> IloSymbolArray </p>
*/
class IloSymbolCollectionFirstI : public IloSymbolExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloSymbolCollectionFirstI(IloEnvI* env, IloAnyCollectionExprI* expr):
	  IloSymbolExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloSymbolCollectionFirstI();
	  void display(ILOSTD(ostream)& out) const;
	  IloAnyCollectionExprI* getExpr() const { return _expr; }
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  virtual IloEncoderI* getEncoder() const {
		  return getEnv()->getSymbolEncoder();
	  }
};



/**
* @group optim.concert.adv
* @show internal
* <p> IloSymbolArray </p>
*/
class IloSymbolCollectionLastI : public IloSymbolExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloSymbolCollectionLastI(IloEnvI* env, IloAnyCollectionExprI* expr):
	  IloSymbolExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloSymbolCollectionLastI();
	  void display(ILOSTD(ostream)& out) const;
	  IloAnyCollectionExprI* getExpr() const { return _expr; }
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  virtual IloEncoderI* getEncoder() const {
		  return getEnv()->getSymbolEncoder();
	  }
};





//---------------------------------------------------------------------------
//   IloIntCollectionUnion
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionUnionI. </p> **/
class IloIntCollectionUnionI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionUnionI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionUnionI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionUnion
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionUnionI. </p> **/
class IloNumCollectionUnionI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionUnionI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionUnionI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionUnion
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionUnionI. </p> **/
class IloAnyCollectionUnionI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionUnionI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionUnionI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionSymExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionSymExcludeI. </p> **/
class IloIntCollectionSymExcludeI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionSymExcludeI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionSymExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionSymExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionSymExcludeI. </p> **/
class IloNumCollectionSymExcludeI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionSymExcludeI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionSymExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionSymExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionSymExcludeI. </p> **/
class IloAnyCollectionSymExcludeI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionSymExcludeI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionSymExcludeI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


//---------------------------------------------------------------------------
//   IloIntCollectionExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionExcludeI. </p> **/
class IloIntCollectionExcludeI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionExcludeI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionExcludeI. </p> **/
class IloNumCollectionExcludeI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionExcludeI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionExcludeI. </p> **/
class IloAnyCollectionExcludeI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionExcludeI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionExcludeI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionInter
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionInterI. </p> **/
class IloIntCollectionInterI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionInterI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionInterI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionInter
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionInterI. </p> **/
class IloNumCollectionInterI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionInterI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionInterI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionInter
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionInterI. </p> **/
class IloAnyCollectionInterI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionInterI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionInterI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionAsNumCollectionI. </p> **/
class IloIntCollectionAsNumCollectionI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionAsNumCollectionI(IloEnvI* env, IloIntCollectionExprI* left);
  virtual ~IloIntCollectionAsNumCollectionI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getExpr() const { return _expr;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


#endif
