// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __CONCERT_ilomemberH
#define __CONCERT_ilomemberH

#if !defined(__CONCERT_iloenvH)
#include <ilconcert/iloenv.h>
#endif
#if !defined(__CONCERT_ilomodelH)
#include <ilconcert/ilomodel.h>
#endif

#if !defined(__CONCERT_ilocollectionH)
#include <ilconcert/ilocollection.h>
#endif
#if !defined(__CONCERT_ilotuplecollectionH)
#include <ilconcert/ilotuplecollection.h>
#endif
#if !defined(__CONCERT_ilotupleH)
#include <ilconcert/ilotuple.h>
#endif

/////////////////
//
//  Constraints
//
class IloSymbolExprArg;
class IloTupleExprArg;
class IloTupleSet;
class IloAnyExprI;

IloConstraint IloMember(const IloEnv env, const IloTupleExprArg exp, const IloTupleSetExprArg s);

IloConstraint IloMember(const IloEnv env, const IloSymbolExprArg expr, const IloSymbolArray elements);

IloConstraint IloNotMember(const IloEnv env, const IloTupleExprArg exp, const IloTupleSetExprArg s);

IloConstraint IloNotMember(const IloEnv env, const IloIntExprArg expr, const IloIntArray elements);

IloConstraint IloNotMember(const IloEnv env, const IloNumExprArg expr, const IloNumArray elements);

IloConstraint IloNotMember(const IloEnv env, const IloSymbolExprArg expr, const IloSymbolArray elements);


class IloTupleSetExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloTupleExprArgI* _exp;
	IloTupleSetExprArgI* _coll;
public:
	IloTupleSetExprMemberI(IloEnvI* env, IloTupleExprArgI* exp, IloTupleSetExprArgI* coll);
    virtual ~IloTupleSetExprMemberI();
	void visitSubExtractables(IloExtractableVisitor* v);
	IloTupleExprArgI* getTupleExpr() const { return _exp; }
	IloTupleSetExprArgI* getTupleSetExpr() const { return _coll; }
	ILOEXTROTHERDECL
};


class IloAnyArrayMemberI : public IloConstraintI {
	ILOEXTRMEMBERS2DECL(IloAnyArrayMemberI,IloConstraintI,
		IloAnyExprI*, _expr,
		IloAnyArray, _elements)
		virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	virtual ~IloAnyArrayMemberI();
	IloAnyExprI* getExpr() const {return _expr;}
	IloAnyArray getElements() const {return _elements;}
};

#endif


