// -------------------------------------------------------------- -*- C++ -*-
//							     ILOG header file
// File: ilconcert/ilxml/iloi18n.h
// --------------------------------------------------------------------------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
// Declaration of the IloXmlI18N class that contains several I18N-related
// routines.
// Defined in library ilconcert/ilxml
// --------------------------------------------------------------------------
#ifndef __XML_iloi18nH
#define __XML_iloi18nH

#if !defined(__XML_ilomacrosH)
#include <ilconcert/ilxml/ilomacros.h>
#endif

typedef IloXmlUChar  IloXmlUTF8;
typedef IloXmlUShort IloXmlUTF16;
typedef IloXmlUInt   IloXmlUTF32;

// --------------------------------------------------------------------------
class IloXmlI18n
{
public:
    static IloXmlUTF16* Utf8ToUtf16(IloXmlUInt& outputSize,
				IloXmlUInt  inputSize,
				const IloXmlUTF8* input);
    static IloXmlUTF8* Utf16ToUtf8(IloXmlUInt& outputSize,
			       IloXmlUInt  inputSize,
			       const IloXmlUTF16* input);

    static IloXmlUTF16* EBCDICToUtf16(IloXmlUInt& outputSize,
				      IloXmlUInt  inputSize,
				      const char* input);
    static char* Utf16ToEBCDIC(IloXmlUInt& outputSize,
					IloXmlUInt  inputSize,
					const IloXmlUTF16* input);

};

#endif /* !__XML_iloi18nH */
