// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------


#ifndef __XML_iloxmlboxH
#define __XML_iloxmlboxH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif



// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlPack
// ----------------------------------------------------------*- C++ -*-------


class IloPackI;


/**
 * @show internal
 *
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Pack makes it possible to serialize an IloPackI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Pack : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Pack::getTagName();
  }
  IloXmlInfo_Pack(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloPackI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloPackI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlBox
// ----------------------------------------------------------*- C++ -*-------


class IloBoxI;


/**
 * @show internal
 *
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Box makes it possible to serialize an IloBoxI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Box : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Box::getTagName();
  }
  IloXmlInfo_Box(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloBoxI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloBoxI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNotOverlapConstraint
// ----------------------------------------------------------*- C++ -*-------


class IloNotOverlapConstraintI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NotOverlapConstraint makes it possible to serialize an IloNotOverlapConstraintI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NotOverlapConstraint : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NotOverlapConstraint::getTagName();
  }
  IloXmlInfo_NotOverlapConstraint(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNotOverlapConstraintI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNotOverlapConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlContainmentConstraint
// ----------------------------------------------------------*- C++ -*-------


class IloContainmentConstraintI;


/**
 * @show internal
 *
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_ContainmentConstraint makes it possible to serialize an IloContainmentConstraintI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ContainmentConstraint : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ContainmentConstraint::getTagName();
  }
  IloXmlInfo_ContainmentConstraint(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloContainmentConstraintI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloContainmentConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlOverlapInDimensionConstraint
// ----------------------------------------------------------*- C++ -*-------


class IloOverlapInDimensionConstraintI;


/**
 * @show internal
 *
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_OverlapInDimensionConstraint makes it possible to serialize an IloOverlapInDimensionConstraintI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_OverlapInDimensionConstraint : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_OverlapInDimensionConstraint::getTagName();
  }
  IloXmlInfo_OverlapInDimensionConstraint(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloOverlapInDimensionConstraintI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloOverlapInDimensionConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNotOverlapInDimensionConstraint
// ----------------------------------------------------------*- C++ -*-------


class IloNotOverlapInDimensionConstraintI;


/**
 * @show internal
 *
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NotOverlapInDimensionConstraint makes it possible to serialize an IloNotOverlapInDimensionConstraintI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NotOverlapInDimensionConstraint : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NotOverlapInDimensionConstraint::getTagName();
  }
  IloXmlInfo_NotOverlapInDimensionConstraint(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNotOverlapInDimensionConstraintI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNotOverlapInDimensionConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlPrecedenceInDimensionConstraint
// ----------------------------------------------------------*- C++ -*-------


class IloPrecedenceInDimensionConstraintI;


/**
 * @show internal
 *
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_PrecedenceInDimensionConstraint makes it possible to serialize an IloPrecedenceInDimensionConstraintI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_PrecedenceInDimensionConstraint : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_PrecedenceInDimensionConstraint::getTagName();
  }
  IloXmlInfo_PrecedenceInDimensionConstraint(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloPrecedenceInDimensionConstraintI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloPrecedenceInDimensionConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



#endif
