
// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------


#ifndef __XML_iloxmlcppconstraintH
#define __XML_iloxmlcppconstraintH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif





class IloConstConstraintI;


/**
* @show internal
*
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_ConstConstraint 
* makes it possible to serialize an IloConstConstraintI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_ConstConstraint : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ConstConstraint::getTagName();
  }
  IloXmlInfo_ConstConstraint(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloConstConstraintI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloConstConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};








// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlAllMinDistance
// ----------------------------------------------------------*- C++ -*-------


class IloAllMinDistanceI;


/**
* @show internal
*
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_AllMinDistance makes it possible
* to serialize an IloAllMinDistanceI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_AllMinDistance : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_AllMinDistance::getTagName();
  }
  IloXmlInfo_AllMinDistance(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloAllMinDistanceI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloAllMinDistanceI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntAbstraction
// ----------------------------------------------------------*- C++ -*-------


class IloIntAbstractionI;


/**
* @show internal
*
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_IntAbstraction 
* makes it possible to serialize an IloIntAbstractionI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_IntAbstraction : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntAbstraction::getTagName();
  }
  IloXmlInfo_IntAbstraction(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntAbstractionI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntAbstractionI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlBoolIntAbstraction
// ----------------------------------------------------------*- C++ -*-------


class IloBoolIntAbstractionI;


/**
* @show internal
*
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_BoolIntAbstraction 
* makes it possible to serialize an IloBoolIntAbstractionI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_BoolIntAbstraction : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_BoolIntAbstraction::getTagName();
  }
  IloXmlInfo_BoolIntAbstraction(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloBoolIntAbstractionI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloBoolIntAbstractionI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntArrayEqUnion
// ----------------------------------------------------------*- C++ -*-------


class IloIntArrayEqUnionI;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_IntArrayEqUnion 
* makes it possible to serialize an IloIntArrayEqUnionI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_IntArrayEqUnion : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntArrayEqUnion::getTagName();
  }
  IloXmlInfo_IntArrayEqUnion(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntArrayEqUnionI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntArrayEqUnionI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntArrayMember
// ----------------------------------------------------------*- C++ -*-------


class IloIntArrayMemberI;


/**
* @show internal
*
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_IntArrayMember 
* makes it possible to serialize an IloIntArrayMemberI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_IntArrayMember : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntArrayMember::getTagName();
  }
  IloXmlInfo_IntArrayMember(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntArrayMemberI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntArrayMemberI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumArrayMember
// ----------------------------------------------------------*- C++ -*-------


class IloNumArrayMemberI;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_NumArrayMember 
* makes it possible to serialize an IloNumArrayMemberI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_NumArrayMember : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumArrayMember::getTagName();
  }
  IloXmlInfo_NumArrayMember(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumArrayMemberI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumArrayMemberI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntEqPartition
// ----------------------------------------------------------*- C++ -*-------


class IloIntEqPartitionI;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_IntEqPartition 
* makes it possible to serialize an IloIntEqPartitionI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_IntEqPartition : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntEqPartition::getTagName();
  }
  IloXmlInfo_IntEqPartition(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntEqPartitionI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntEqPartitionI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntPartition2
// ----------------------------------------------------------*- C++ -*-------


class IloIntPartition2I;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_IntPartition2 
* makes it possible to serialize an IloIntPartition2I in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_IntPartition2 : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntPartition2::getTagName();
  }
  IloXmlInfo_IntPartition2(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntPartition2I* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntPartition2I*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntPartition1
// ----------------------------------------------------------*- C++ -*-------


class IloIntPartition1I;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_IntPartition1 
* makes it possible to serialize an IloIntPartition1I in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_IntPartition1 : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntPartition1::getTagName();
  }
  IloXmlInfo_IntPartition1(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntPartition1I* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntPartition1I*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSequence
// ----------------------------------------------------------*- C++ -*-------


class IloSequenceI;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_Sequence 
* makes it possible to serialize an IloSequenceI in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_Sequence : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Sequence::getTagName();
  }
  IloXmlInfo_Sequence(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloSequenceI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloSequenceI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntTableElementConstraint2
// ----------------------------------------------------------*- C++ -*-------


class IloIntTableElementConstraint2I;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_IntTableElementConstraint2 
* makes it possible to serialize an IloIntTableElementConstraint2I in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_IntTableElementConstraint2 : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntTableElementConstraint2::getTagName();
  }
  IloXmlInfo_IntTableElementConstraint2(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntTableElementConstraint2I* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntTableElementConstraint2I*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSOS1
// ----------------------------------------------------------*- C++ -*-------


class IloSOS1I;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_SOS1 
* makes it possible to serialize an IloSOS1I in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_SOS1 : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_SOS1::getTagName();
  }
  IloXmlInfo_SOS1(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloSOS1I* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloSOS1I*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSOS2
// ----------------------------------------------------------*- C++ -*-------


class IloSOS2I;


/**
* @show internal
* @group optim.concert.xmlconcert
*
* <p>An instance of IloXmlInfo_SOS2 
* makes it possible to serialize an IloSOS2I in XML. </p>
* @see IloXmlContextI
* @see IloXmlInfo
* @see IloXmlReader
* @see IloXmlWriter
**/
class IloXmlInfo_SOS2 : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_SOS2::getTagName();
  }
  IloXmlInfo_SOS2(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloSOS2I* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloSOS2I*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

#endif


