// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlcppexpressionH
#define __XML_iloxmlcppexpressionH

#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------

// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlArcCos
// ----------------------------------------------------------*- C++ -*-------
class IloArcCosI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_ArcCos 
 * makes it possible to serialize an IloArcCosI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ArcCos : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ArcCos::getTagName();
  }
  IloXmlInfo_ArcCos(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloArcCosI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloArcCosI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------

// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlArcSin
// ----------------------------------------------------------*- C++ -*-------

class IloArcSinI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_ArcSin 
 * makes it possible to serialize an IloArcSinI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ArcSin : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ArcSin::getTagName();
  }
  IloXmlInfo_ArcSin(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloArcSinI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloArcSinI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlArcTan
// ----------------------------------------------------------*- C++ -*-------


class IloArcTanI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_ArcTan 
 * makes it possible to serialize an IloArcTanI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ArcTan : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ArcTan::getTagName();
  }
  IloXmlInfo_ArcTan(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloArcTanI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI,
			IloXmlElement* masterElement){
    return write(writer, (IloArcTanI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlCos
// ----------------------------------------------------------*- C++ -*-------


class IloCosI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_Cos 
 * makes it possible to serialize an IloCosI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Cos : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Cos::getTagName();
  }
  IloXmlInfo_Cos(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloCosI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloCosI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSin
// ----------------------------------------------------------*- C++ -*-------


class IloSinI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_Sin 
 * makes it possible to serialize an IloSinI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Sin : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Sin::getTagName();
  }
  IloXmlInfo_Sin(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloSinI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloSinI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlTan
// ----------------------------------------------------------*- C++ -*-------


class IloTanI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_Tan 
 * makes it possible to serialize an IloTanI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Tan : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Tan::getTagName();
  }
  IloXmlInfo_Tan(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloTanI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloTanI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntArrayElement
// ----------------------------------------------------------*- C++ -*-------


class IloIntArrayElementI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_IntArrayElement 
 * makes it possible to serialize an IloIntArrayElementI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntArrayElement : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntArrayElement::getTagName();
  }
  IloXmlInfo_IntArrayElement(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, IloIntArrayElementI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntArrayElementI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntExprArrayElement
// ----------------------------------------------------------*- C++ -*-------


class IloIntExprArrayElementI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_IntExprArrayElement 
 * makes it possible to serialize an IloIntExprArrayElementI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntExprArrayElement : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntExprArrayElement::getTagName();
  }
  IloXmlInfo_IntExprArrayElement(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntExprArrayElementI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntExprArrayElementI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumExprArrayElement
// ----------------------------------------------------------*- C++ -*-------


class IloNumExprArrayElementI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumExprArrayElement 
 * makes it possible to serialize an IloNumExprArrayElementI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumExprArrayElement : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumExprArrayElement::getTagName();
  }
  IloXmlInfo_NumExprArrayElement(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumExprArrayElementI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumExprArrayElementI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntModulo
// ----------------------------------------------------------*- C++ -*-------


class IloIntModuloI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_IntModulo 
 * makes it possible to serialize an IloIntModuloI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntModulo : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntModulo::getTagName();
  }
  IloXmlInfo_IntModulo(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntModuloI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntModuloI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntModuloCst
// ----------------------------------------------------------*- C++ -*-------


class IloIntModuloCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_IntModuloCst 
 * makes it possible to serialize an IloIntModuloCstI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntModuloCst : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntModuloCst::getTagName();
  }
  IloXmlInfo_IntModuloCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntModuloCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntModuloCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




class IloIntDExprI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_IntDExpr 
 * makes it possible to serialize an IloIntDExprI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntDExpr : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntDExpr::getTagName();
  }
  IloXmlInfo_IntDExpr(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntDExprI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntDExprI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



class IloNumDExprI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumDExpr 
 * makes it possible to serialize an IloNumDExprI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumDExpr : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumDExpr::getTagName();
  }
  IloXmlInfo_NumDExpr(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumDExprI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumDExprI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






class IloNumCeilI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumCeil 
 * makes it possible to serialize an IloNumCeilI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumCeil : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumCeil::getTagName();
  }
  IloXmlInfo_NumCeil(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumCeilI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumCeilI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






class IloNumFloorI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumFloor 
 * makes it possible to serialize an IloNumFloorI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumFloor : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumFloor::getTagName();
  }
  IloXmlInfo_NumFloor(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumFloorI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumFloorI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloNumTruncI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumTrunc 
 * makes it possible to serialize an IloNumTruncI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumTrunc : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumTrunc::getTagName();
  }
  IloXmlInfo_NumTrunc(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumTruncI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumTruncI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloDistToIntI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_DistToInt 
 * makes it possible to serialize an IloDistToIntI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_DistToInt : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_DistToInt::getTagName();
  }
  IloXmlInfo_DistToInt(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloDistToIntI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloDistToIntI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloNumFractI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumFract 
 * makes it possible to serialize an IloNumFractI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumFract : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumFract::getTagName();
  }
  IloXmlInfo_NumFract(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumFractI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumFractI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloNumRoundI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumRound 
 * makes it possible to serialize an IloNumRoundI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumRound : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumRound::getTagName();
  }
  IloXmlInfo_NumRound(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumRoundI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumRoundI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloNumToIntI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumToInt 
 * makes it possible to serialize an IloNumToIntI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumToInt : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumToInt::getTagName();
  }
  IloXmlInfo_NumToInt(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumToIntI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumToIntI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






class IloCountI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_Count 
 * makes it possible to serialize an IloCountI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Count : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Count::getTagName();
  }
  IloXmlInfo_Count(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloCountI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloCountI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



class IloConditionalIntExprI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_ConditionalIntExpr 
 * makes it possible to serialize an IloConditionalIntExprI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ConditionalIntExpr : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ConditionalIntExpr::getTagName();
  }
  IloXmlInfo_ConditionalIntExpr(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloConditionalIntExprI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloConditionalIntExprI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




class IloConditionalNumExprI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_ConditionalNumExpr 
 * makes it possible to serialize an IloConditionalNumExprI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ConditionalNumExpr : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ConditionalNumExpr::getTagName();
  }
  IloXmlInfo_ConditionalNumExpr(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloConditionalNumExprI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloConditionalNumExprI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



class IloStandardDeviationI ;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_Count 
 * makes it possible to serialize an IloCountI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_StandardDeviation : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_StandardDeviation::getTagName();
  }
  IloXmlInfo_StandardDeviation(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloStandardDeviationI * exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloStandardDeviationI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloMapIntIndexI;

class IloXmlInfo_MapIntIndex : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_MapIntIndex::getTagName();
  }
  IloXmlInfo_MapIntIndex(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloMapIntIndexI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloMapIntIndexI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloMapIntExprIndexI;

class IloXmlInfo_MapIntExprIndex : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_MapIntExprIndex::getTagName();
  }
  IloXmlInfo_MapIntExprIndex(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloMapIntExprIndexI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloMapIntExprIndexI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloIntSubMapSubI;

class IloXmlInfo_IntSubMapSub : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntSubMapSub::getTagName();
  }
  IloXmlInfo_IntSubMapSub(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloIntSubMapSubI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloIntSubMapSubI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


class IloIntSubMapRootI;

class IloXmlInfo_IntSubMapRoot : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntSubMapRoot::getTagName();
  }
  IloXmlInfo_IntSubMapRoot(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloIntSubMapRootI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloIntSubMapRootI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

//==========================================================================

class IloIntExprSubMapSubI;

class IloXmlInfo_IntExprSubMapSub : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntExprSubMapSub::getTagName();
  }
  IloXmlInfo_IntExprSubMapSub(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloIntExprSubMapSubI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloIntExprSubMapSubI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


class IloIntExprSubMapRootI;

class IloXmlInfo_IntExprSubMapRoot : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntExprSubMapRoot::getTagName();
  }
  IloXmlInfo_IntExprSubMapRoot(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloIntExprSubMapRootI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloIntExprSubMapRootI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



class IloMapNumIndexI;

class IloXmlInfo_MapNumIndex : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_MapNumIndex::getTagName();
  }
  IloXmlInfo_MapNumIndex(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloMapNumIndexI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloMapNumIndexI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



class IloMapNumExprIndexI;

class IloXmlInfo_MapNumExprIndex : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_MapNumExprIndex::getTagName();
  }
  IloXmlInfo_MapNumExprIndex(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloMapNumExprIndexI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloMapNumExprIndexI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





class IloNumSubMapSubI;

class IloXmlInfo_NumSubMapSub : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumSubMapSub::getTagName();
  }
  IloXmlInfo_NumSubMapSub(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloNumSubMapSubI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloNumSubMapSubI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


class IloNumSubMapRootI;

class IloXmlInfo_NumSubMapRoot : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumSubMapRoot::getTagName();
  }
  IloXmlInfo_NumSubMapRoot(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloNumSubMapRootI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloNumSubMapRootI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

//==========================================================================

class IloNumExprSubMapSubI;

class IloXmlInfo_NumExprSubMapSub : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumExprSubMapSub::getTagName();
  }
  IloXmlInfo_NumExprSubMapSub(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloNumExprSubMapSubI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloNumExprSubMapSubI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


class IloNumExprSubMapRootI;

class IloXmlInfo_NumExprSubMapRoot : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumExprSubMapRoot::getTagName();
  }
  IloXmlInfo_NumExprSubMapRoot(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloNumExprSubMapRootI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloNumExprSubMapRootI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


#endif


