// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlmetaH
#define __XML_iloxmlmetaH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif


class IloAndI;
class IloOrI;
class IloRangeI;



class IloConstraintI;
class IloIntExprI;
class IloNumExprI;



class IloXmlInfo_IntExpr : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntExpr::getTagName(); }
  IloXmlInfo_IntExpr(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntExprI* intExprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntExprI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


class IloXmlInfo_NumExpr : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_NumExpr::getTagName(); }
  IloXmlInfo_NumExpr(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloNumExprI* numExprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumExprI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

class IloXmlInfo_Constraint : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_Constraint::getTagName(); }
  IloXmlInfo_Constraint(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloConstraintI* ConstraintI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_And</code> makes it possible 
 * to serialize an <code>IloAndI</code> in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */


class IloXmlInfo_And : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_And::getTagName(); }
  IloXmlInfo_And(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloAndI* AndI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloAndI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
  IloBool setConstraintList(IloXmlWriter writer, IloXmlElement* element, IloAndI* AndI);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloAndI* exprI);

};




/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_Or</code> 
 * makes it possible to serialize an IloOrI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_Or : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_Or::getTagName(); }
  IloXmlInfo_Or(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloOrI* OrI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloOrI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
  IloBool setConstraintList(IloXmlWriter writer, IloXmlElement* element, IloOrI* OrI);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloOrI* exprI);

};



/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_Range</code> 
 * makes it possible to serialize an IloRangeI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_Range : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_Range::getTagName(); }
  IloXmlInfo_Range(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloRangeI* rangeI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloRangeI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);

protected:
  IloBool setBounds(IloXmlWriter writer, IloXmlElement* element, IloRangeI* rangeI);
  IloBool setRangeExpr(IloXmlWriter writer, IloXmlElement* element, IloRangeI* rangeI);


};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntGe</code> 
 * makes it possible to read an IloRangeI with IntExpr as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntGe : public IloXmlInfo {
	
public:
  IloXmlInfo_IntGe(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntGe::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntLe</code> 
 * makes it possible to read an IloRangeI with IntExprs 
 * as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntLe : public IloXmlInfo {
	
public:
  IloXmlInfo_IntLe(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntLe::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_NumGeCst</code> 
 * makes it possible to read an IloRangeI with NumExpr 
 * and double as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumGeCst : public IloXmlInfo {
	
public:
  IloXmlInfo_NumGeCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_NumGeCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_NumLeCst</code> 
 * makes it possible to read an IloRangeI with NumExpr 
 * and double as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumLeCst : public IloXmlInfo {
	
public:
  IloXmlInfo_NumLeCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_NumLeCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntGtCst</code> 
 * makes it possible to read an IloRangeI with IntExpr 
 * and int as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntGtCst : public IloXmlInfo {
	
public:
  IloXmlInfo_IntGtCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntGtCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntLtCst</code> 
 * makes it possible to read an IloRangeI with IntExpr 
 * and int as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntLtCst : public IloXmlInfo {
	
public:
  IloXmlInfo_IntLtCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntLtCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_NumEqCst</code> 
 * makes it possible to read an IloRangeI with NumExpr 
 * and double as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumEqCst : public IloXmlInfo {
	
public:
  IloXmlInfo_NumEqCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_NumEqCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntEqCst</code> 
 * makes it possible to read an IloRangeI with IntExpr 
 * and int as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntEqCst : public IloXmlInfo {
	
public:
  IloXmlInfo_IntEqCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntEqCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntEq</code> 
 * makes it possible to read an IloRangeI with IntExpr 
 * and IntExpr as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntEq : public IloXmlInfo {
	
public:
  IloXmlInfo_IntEq(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntEq::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntLeCst</code> 
 * makes it possible to read an IloRangeI with IntExpr 
 * and int as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntLeCst : public IloXmlInfo {
	
public:
  IloXmlInfo_IntLeCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntLeCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntGeCst</code> 
 * makes it possible to read an IloRangeI with IntExpr 
 * and int as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntGeCst : public IloXmlInfo {
	
public:
  IloXmlInfo_IntGeCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntGeCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlDistribute
// ----------------------------------------------------------*- C++ -*-------

class IloDistributeI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Distribute 
 * makes it possible to serialize an IloDistributeI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_Distribute : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Distribute::getTagName();
  }
  IloXmlInfo_Distribute(IloXmlContextI* context);
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloDistributeI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloDistributeI* exprI);

  virtual IloBool write(IloXmlWriter writer, IloDistributeI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloDistributeI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlLexicographic
// ----------------------------------------------------------*- C++ -*-------

class IloLexicographicI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Lexicographic 
 * makes it possible to serialize an IloLexicographicI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_Lexicographic : public IloXmlInfo { 
public: 
  static const char* getTagName(); 
  virtual const char* getTag();
  
  IloXmlInfo_Lexicographic(IloXmlContextI* context); 

  virtual IloBool writeXml(IloXmlWriter writer, IloLexicographicI* exprI, IloXmlElement* masterElement); 
  virtual IloBool writeXml(IloXmlWriter writer, const IloExtractableI* extractableI, IloXmlElement* masterElement);
  virtual IloExtractableI* readXml(IloXmlReader reader, IloXmlElement* element); 
}; 


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_Imply</code> 
 * makes it possible to read a LessThanOrEqalTo with 
 * Constraint and Constraint as arguments in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_Imply : public IloXmlInfo {
	
public:
  IloXmlInfo_Imply(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_Imply::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntSum</code> 
 * makes it possible to read a sum with IntExprArray as argument in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntSum : public IloXmlInfo {
	
public:
  IloXmlInfo_IntSum(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntSum::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_NumSum</code> 
 * makes it possible to read a sum with NumExprArray as argument in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumSum : public IloXmlInfo {
	
public:
  IloXmlInfo_NumSum(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_NumSum::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_NumOpposite</code> 
 * makes it possible to read the
 * opposite of a  NumExpr as argument in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumOpposite : public IloXmlInfo {
	
public:
  IloXmlInfo_NumOpposite(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_NumOpposite::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntOpposite</code> 
 * makes it possible to read the
 * opposite of an IntExpr as argument in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_IntOpposite : public IloXmlInfo {
	
public:
  IloXmlInfo_IntOpposite(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntOpposite::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


#endif
