// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlmodelH
#define __XML_iloxmlmodelH



#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif


class IloModelI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_Model</code> 
 * makes it possible to serialize an IloModelI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_Model : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_Model::getTagName(); }
  IloXmlInfo_Model(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloModelI* sinI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloModelI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloModelI* exprI);

};


#endif
