// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------


#ifndef __XML_iloxmlobjectiveH
#define __XML_iloxmlobjectiveH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

class IloObjectiveI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_Objective</code> 
 * makes it possible to serialize an IloObjectiveI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_Objective : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_Objective::getTagName(); }
  IloXmlInfo_Objective(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloObjectiveI* objectiveI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloObjectiveI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);

  virtual void writeSolution(IloXmlWriter writer, const IloSolution solution, IloObjectiveI* objI);
  virtual void writeSolution(IloXmlWriter writer, const IloSolution solution, const IloExtractable extractable){
    writeSolution(writer, solution, (IloObjectiveI*)extractable.getImpl());
  }
  virtual IloBool readSolution(IloXmlReader reader, IloSolution solution, IloXmlElement* element);

protected:
  IloObjective::Sense getObjectiveSense(IloXmlReader reader, IloXmlElement* element);
  IloBool setObjective(IloXmlWriter writer, IloXmlElement* element, IloObjectiveI* ObjectiveI);
};


#endif
