// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlsemicontvararrayH
#define __XML_iloxmlsemicontvararrayH



#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

class IloSemiContVarArray;

/**
 * @show internal
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_SemiContVarArray</code> 
 * makes it possible to serialize an IloSemiContVarArray in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/

class IloXmlInfo_SemiContVarArray : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_SemiContVarArray::getTagName(); }
  IloXmlInfo_SemiContVarArray(IloXmlContextI* context);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  virtual int write(IloXmlWriter writer, IloSemiContVarArray* array, IloXmlElement* masterElement);
  IloBool setVarContent(IloXmlWriter writer, IloSemiContVarArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloSemiContVarArray* varArray);


};


#endif
