// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlsetH
#define __XML_iloxmlsetH



#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

class IloIntSetDiffI;
class IloIntSetEqI;
class IloIntSubsetI;
class IloIntSubsetEqI;
class IloIntTableSetConstraintI;
class IloIntTupleSet;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntSetNeq</code> 
 * makes it possible to serialize an IloIntSetDiffI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_IntSetNeq : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntSetNeq::getTagName(); }
  IloXmlInfo_IntSetNeq(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntSetDiffI* IntSetDiffI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntSetDiffI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);

  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloIntSetDiffI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloIntSetDiffI* exprI);

};


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntSetEq</code> 
 * makes it possible to serialize an IloIntSetEqI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_IntSetEq : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntSetEq::getTagName(); }
  IloXmlInfo_IntSetEq(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntSetEqI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntSetEqI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);

  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloIntSetEqI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloIntSetEqI* exprI);

};



/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntSubset</code> 
 * makes it possible to serialize an IloIntSubsetI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_IntSubset : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntSubset::getTagName(); }
  IloXmlInfo_IntSubset(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntSubsetI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntSubsetI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);

  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloIntSubsetI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloIntSubsetI* exprI);

};


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntSubsetEq</code> 
 * makes it possible to serialize an IloIntSubsetEqI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_IntSubsetEq : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntSubsetEq::getTagName(); }
  IloXmlInfo_IntSubsetEq(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntSubsetEqI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntSubsetEqI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloIntSubsetEqI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloIntSubsetEqI* exprI);

};



/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntTableSetConstraint</code> 
 * makes it possible to serialize an IloIntTableSetConstraintI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_IntTableSetConstraint : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntTableSetConstraint::getTagName(); }
  IloXmlInfo_IntTableSetConstraint(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntTableSetConstraintI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntTableSetConstraintI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_NotSubsetEq</code> 
 * makes it possible to read an IloNot(IloSubsetEq) from XML. 
 * For internal use only with C# and Java XML.</p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_NotSubsetEq : public IloXmlInfo {
	
public:
  IloXmlInfo_NotSubsetEq(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_NotSubsetEq::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntTupleSet</code> 
 * makes it possible to serialize an IloIntTupleSetI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloIntTupleSetI;
class IloXmlInfo_IntTupleSet : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntTupleSet::getTagName(); }
  IloXmlInfo_IntTupleSet(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntTupleSetI* IntTupleSetI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntTupleSetI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
  void setIntTupleSet(IloXmlWriter writer, IloXmlElement* element, IloIntTupleSetI* exprI);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloIntTupleSetI* varArray);

};


#endif
